Index: src/FLEXPART_MPI.f90
===================================================================
--- src/FLEXPART_MPI.f90	(revision 79abee91596b840b8be5c7b61935df1d168db264)
+++ src/FLEXPART_MPI.f90	(revision 16b61a5e2d3b1020be1cff080e479ba26f3f7063)
@@ -55,13 +55,13 @@
 
 
-! Initialize mpi
-!*********************
+  ! Initialize mpi
+  !*********************
   call mpif_init
 
   if (mp_measure_time) call mpif_mtime('flexpart',0)
 
-! Initialize arrays in com_mod 
-!*****************************
-  call com_mod_allocate_part(maxpart_mpi)
+  ! Initialize arrays in com_mod 
+  !*****************************
+  if (.not.lmpreader) call com_mod_allocate_part(maxpart_mpi)
 
   ! Generate a large number of random numbers
@@ -306,7 +306,9 @@
   endif
 
-  do j=1, size(itra1) ! maxpart_mpi
-    itra1(j)=-999999999
-  end do
+  if (.not.lmpreader) then
+    do j=1, size(itra1) ! maxpart_mpi
+      itra1(j)=-999999999
+    end do
+  end if
 
   ! For continuation of previous run, read in particle positions
@@ -463,6 +465,8 @@
   if (lroot) then
     write(*,*) '**********************************************'
-    write(*,*) 'Total number of occurences of below-cloud scavenging', tot_blc_count
-    write(*,*) 'Total number of occurences of in-cloud    scavenging', tot_inc_count
+    write(*,*) 'Total number of occurences of below-cloud scavenging', &
+         & tot_blc_count
+    write(*,*) 'Total number of occurences of in-cloud    scavenging', &
+         & tot_inc_count
     write(*,*) '**********************************************'
 
Index: src/boundcond_domainfill_mpi.f90
===================================================================
--- src/boundcond_domainfill_mpi.f90	(revision 0f7835d03c332f5ff00577f23b0a0d791e42b9dc)
+++ src/boundcond_domainfill_mpi.f90	(revision 16b61a5e2d3b1020be1cff080e479ba26f3f7063)
@@ -21,26 +21,37 @@
 
 subroutine boundcond_domainfill(itime,loutend)
-  !                                  i      i
-  !*****************************************************************************
-  !                                                                            *
-  ! Particles are created by this subroutine continuously throughout the       *
-  ! simulation at the boundaries of the domain-filling box.                    *
-  ! All particles carry the same amount of mass which alltogether comprises the*
-  ! mass of air within the box, which remains (more or less) constant.         *
-  !                                                                            *
-  !     Author: A. Stohl                                                       *
-  !                                                                            *
-  !     16 October 2002                                                        *
-  !                                                                            *
-  !*****************************************************************************
-  !                                                                            *
-  ! Variables:                                                                 *
-  !                                                                            *
-  ! nx_we(2)       grid indices for western and eastern boundary of domain-    *
-  !                filling trajectory calculations                             *
-  ! ny_sn(2)       grid indices for southern and northern boundary of domain-  *
-  !                filling trajectory calculations                             *
-  !                                                                            *
-  !*****************************************************************************
+!                                  i      i
+!*****************************************************************************
+!                                                                            *
+! Particles are created by this subroutine continuously throughout the       *
+! simulation at the boundaries of the domain-filling box.                    *
+! All particles carry the same amount of mass which alltogether comprises the*
+! mass of air within the box, which remains (more or less) constant.         *
+!                                                                            *
+!     Author: A. Stohl                                                       *
+!                                                                            *
+!     16 October 2002                                                        *
+!                                                                            *
+!*****************************************************************************
+!                                                                            *
+! Variables:                                                                 *
+!                                                                            *
+! nx_we(2)       grid indices for western and eastern boundary of domain-    *
+!                filling trajectory calculations                             *
+! ny_sn(2)       grid indices for southern and northern boundary of domain-  *
+!                filling trajectory calculations                             *
+!                                                                            *
+!*****************************************************************************
+!  CHANGES                                                                   
+!    08/2016 eso: MPI version:                                                
+!
+!   -Root process release particles and distributes to other processes.
+!    Temporary arrays are used, also for the non-root (receiving) processes.
+!   -The scheme can be improved by having all processes report numpart
+!    (keeping track of how many particles have left the domain), so that
+!    a proportional amount of new particles can be distributed (however
+!    we have a separate function called from timemanager that will
+!    redistribute particles among processes if there are imbalances)     
+!*****************************************************************************
 
   use point_mod
@@ -55,5 +66,6 @@
   integer :: itime,in,indz,indzp,i,loutend
   integer :: j,k,ix,jy,m,indzh,indexh,minpart,ipart,mmass
-  integer :: numactiveparticles
+  integer :: numactiveparticles, numpart_total, rel_counter
+  integer,allocatable,dimension(:) ::  numrel_mpi !, numactiveparticles_mpi
 
   real :: windl(2),rhol(2)
@@ -66,7 +78,12 @@
 
   integer :: idummy = -11
+  integer :: mtag
   logical :: first_call=.true.
-
-  ! Use different seed for each process
+! Sizes of temporary arrays are maxpartfract*maxpart. Increase maxpartfract if 
+! needed.  
+  real,parameter :: maxpartfract=0.1
+  integer :: tmp_size = int(maxpartfract*maxpart)
+
+! Use different seed for each process
   if (first_call) then
     idummy=idummy+mp_seed
@@ -75,6 +92,6 @@
 
 
-  ! If domain-filling is global, no boundary conditions are needed
-  !***************************************************************
+! If domain-filling is global, no boundary conditions are needed
+!***************************************************************
 
   if (gdomainfill) return
@@ -82,8 +99,14 @@
   accmasst=0.
   numactiveparticles=0
-
-  ! Terminate trajectories that have left the domain, if domain-filling
-  ! trajectory calculation domain is not global
-  !********************************************************************
+! Keep track of active particles on each process
+  allocate(numrel_mpi(0:mp_partgroup_np-1))
+! numactiveparticles_mpi(0:mp_partgroup_np-1)
+
+! New particles to be released on each process
+  numrel_mpi(:)=0
+
+! Terminate trajectories that have left the domain, if domain-filling
+! trajectory calculation domain is not global. Done for all processes
+!********************************************************************
 
   do i=1,numpart
